"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useAlgoliaIndex = void 0;

var _get = _interopRequireDefault(require("lodash/get"));

var _react = require("react");

var _algoliaContext = require("../algolia-context");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useAlgoliaIndex = function useAlgoliaIndex(_ref) {
  var indexName = _ref.indexName;

  var _useState = (0, _react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      algoliaIndex = _useState2[0],
      setAlgoliaIndex = _useState2[1];

  var algoliaContext = (0, _react.useContext)(_algoliaContext.AlgoliaContext);
  var index = (0, _get.default)(algoliaContext, indexName);
  (0, _react.useEffect)(function () {
    if (index) {
      setAlgoliaIndex(index);
    }
  }, [indexName, index]);
  return algoliaIndex;
};

exports.useAlgoliaIndex = useAlgoliaIndex;