"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useAlgoliaLazyGetObject = void 0;

var _react = require("react");

var _useAlgoliaIndex = require("./use-algolia-index");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var INITIAL_STATE = {
  lodaing: false,
  object: undefined,
  error: undefined
};

var reducer = function reducer(state, action) {
  switch (action.type) {
    case 'fetching':
      return _objectSpread({}, state, {
        loading: true
      });

    case 'success':
      return _objectSpread({}, INITIAL_STATE, {
        object: action.payload.object,
        loading: false
      });

    case 'error':
      return _objectSpread({}, INITIAL_STATE, {
        error: action.payload.error,
        loading: false
      });

    case 'reset':
      return _objectSpread({}, INITIAL_STATE, {
        loading: false
      });

    default:
      return state;
  }
};

var useAlgoliaLazyGetObject = function useAlgoliaLazyGetObject(_ref) {
  var indexName = _ref.indexName,
      objectId = _ref.objectId,
      _ref$fields = _ref.fields,
      fields = _ref$fields === void 0 ? ['*'] : _ref$fields;

  var _useReducer = (0, _react.useReducer)(reducer, INITIAL_STATE),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      _useReducer2$ = _useReducer2[0],
      object = _useReducer2$.object,
      loading = _useReducer2$.loading,
      error = _useReducer2$.error,
      dispatch = _useReducer2[1];

  var _useState = (0, _react.useState)(true),
      _useState2 = _slicedToArray(_useState, 2),
      waiting = _useState2[0],
      setWaiting = _useState2[1];

  var index = (0, _useAlgoliaIndex.useAlgoliaIndex)({
    indexName: indexName
  });
  var stringifiedFields = JSON.stringify(fields);
  (0, _react.useEffect)(function () {
    var cancelled;

    var getObject =
    /*#__PURE__*/
    function () {
      var _ref3 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(_ref2) {
        var objectId, fields, _object;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                objectId = _ref2.objectId, fields = _ref2.fields;
                dispatch({
                  type: 'fetching'
                });
                _context.prev = 2;
                _context.next = 5;
                return index.getObject(objectId, fields);

              case 5:
                _object = _context.sent;

                if (!cancelled) {
                  _context.next = 8;
                  break;
                }

                return _context.abrupt("return");

              case 8:
                dispatch({
                  type: 'success',
                  payload: {
                    object: _object
                  }
                });
                _context.next = 16;
                break;

              case 11:
                _context.prev = 11;
                _context.t0 = _context["catch"](2);

                if (!cancelled) {
                  _context.next = 15;
                  break;
                }

                return _context.abrupt("return");

              case 15:
                dispatch({
                  type: 'error',
                  payload: {
                    error: _context.t0
                  }
                });

              case 16:
                cancelled = false;

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[2, 11]]);
      }));

      return function getObject(_x) {
        return _ref3.apply(this, arguments);
      };
    }();

    if (!index || waiting) {
      return;
    }

    getObject({
      objectId: objectId,
      fields: fields
    });
    return function () {
      return cancelled = true;
    };
  }, [index, objectId, stringifiedFields, waiting]);
  return [function () {
    return setWaiting(false);
  }, {
    loading: loading,
    error: error,
    object: object,
    index: index
  }];
};

exports.useAlgoliaLazyGetObject = useAlgoliaLazyGetObject;