"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useAlgoliaLazySearch = void 0;

var _react = require("react");

var _useStateHistory3 = require("./use-state-history");

var _useAlgoliaIndex = require("./use-algolia-index");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var INITIAL_STATE = {
  searchResults: undefined,
  loading: false,
  error: undefined
};

var reducer = function reducer(state, action) {
  switch (action.type) {
    case 'fetching':
      return _objectSpread({}, state, {
        loading: true
      });

    case 'success':
      return _objectSpread({}, INITIAL_STATE, {
        searchResults: action.payload.searchResults
      });

    case 'error':
      return _objectSpread({}, INITIAL_STATE, {
        error: action.payload.error
      });

    case 'reset':
      return INITIAL_STATE;

    default:
      return state;
  }
};

var useAlgoliaLazySearch = function useAlgoliaLazySearch(_ref) {
  var indexName = _ref.indexName,
      _ref$query = _ref.query,
      query = _ref$query === void 0 ? '' : _ref$query,
      _ref$filters = _ref.filters,
      filters = _ref$filters === void 0 ? '' : _ref$filters,
      _ref$page = _ref.page,
      page = _ref$page === void 0 ? 0 : _ref$page,
      _ref$hitsPerPage = _ref.hitsPerPage,
      hitsPerPage = _ref$hitsPerPage === void 0 ? 10 : _ref$hitsPerPage,
      _ref$delay = _ref.delay,
      delay = _ref$delay === void 0 ? 800 : _ref$delay,
      _ref$key = _ref.key,
      key = _ref$key === void 0 ? 0 : _ref$key,
      props = _objectWithoutProperties(_ref, ["indexName", "query", "filters", "page", "hitsPerPage", "delay", "key"]);

  var handlerRef = (0, _react.useRef)();

  var _useReducer = (0, _react.useReducer)(reducer, INITIAL_STATE),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      _useReducer2$ = _useReducer2[0],
      loading = _useReducer2$.loading,
      searchResults = _useReducer2$.searchResults,
      error = _useReducer2$.error,
      dispatch = _useReducer2[1];

  var _useStateHistory = (0, _useStateHistory3.useStateHistory)(query),
      getPreviousQuery = _useStateHistory.getPrevious;

  var _useStateHistory2 = (0, _useStateHistory3.useStateHistory)(key),
      getPreviousKey = _useStateHistory2.getPrevious;

  var _useState = (0, _react.useState)(true),
      _useState2 = _slicedToArray(_useState, 2),
      waiting = _useState2[0],
      setWaiting = _useState2[1];

  var index = (0, _useAlgoliaIndex.useAlgoliaIndex)({
    indexName: indexName
  });
  (0, _react.useEffect)(function () {
    var cancelled;

    var search =
    /*#__PURE__*/
    function () {
      var _ref3 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(_ref2) {
        var _ref2$query, query, _ref2$page, page, _ref2$filters, filters, _ref2$hitsPerPage, hitsPerPage, _searchResults;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _ref2$query = _ref2.query, query = _ref2$query === void 0 ? '' : _ref2$query, _ref2$page = _ref2.page, page = _ref2$page === void 0 ? 0 : _ref2$page, _ref2$filters = _ref2.filters, filters = _ref2$filters === void 0 ? '' : _ref2$filters, _ref2$hitsPerPage = _ref2.hitsPerPage, hitsPerPage = _ref2$hitsPerPage === void 0 ? 10 : _ref2$hitsPerPage;
                dispatch({
                  type: 'fetching'
                });
                _context.prev = 2;
                _context.next = 5;
                return index.search(_objectSpread({
                  query: query,
                  filters: filters,
                  page: page < 0 ? 0 : page,
                  hitsPerPage: hitsPerPage
                }, props));

              case 5:
                _searchResults = _context.sent;

                if (!cancelled) {
                  _context.next = 8;
                  break;
                }

                return _context.abrupt("return");

              case 8:
                dispatch({
                  type: 'success',
                  payload: {
                    searchResults: _searchResults
                  }
                });
                _context.next = 16;
                break;

              case 11:
                _context.prev = 11;
                _context.t0 = _context["catch"](2);

                if (!cancelled) {
                  _context.next = 15;
                  break;
                }

                return _context.abrupt("return");

              case 15:
                dispatch({
                  type: 'error',
                  payload: {
                    error: _context.t0
                  }
                });

              case 16:
                cancelled = false;

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[2, 11]]);
      }));

      return function search(_x) {
        return _ref3.apply(this, arguments);
      };
    }();

    if (!index || waiting) {
      return;
    }

    if (getPreviousKey() !== key) {
      index.clearCache();
    }

    if (getPreviousQuery() !== query && !!query) {
      handlerRef.current = setTimeout(function () {
        return search({
          query: query,
          filters: filters,
          page: page,
          hitsPerPage: hitsPerPage
        });
      }, delay);
    } else {
      search({
        query: query,
        filters: filters,
        page: page,
        hitsPerPage: hitsPerPage
      });
    }

    return function () {
      cancelled = true;

      if (handlerRef.current) {
        clearTimeout(handlerRef.current);
      }
    };
  }, [query, filters, page, hitsPerPage, index, key, waiting, delay]);
  return [function () {
    return setWaiting(false);
  }, {
    loading: loading,
    error: error,
    searchResults: searchResults,
    index: index
  }];
};

exports.useAlgoliaLazySearch = useAlgoliaLazySearch;